import GLOOP.*;
public class Taste {
  // Instanzvariablen - ersetzen Sie das folgende Beispiel mit Ihren Variablen
  private double xPosition;
  private double yPosition;

  private int farbeRot;
  private int farbeGruen;
  private int farbeBlau;

  private String text;
  private GLTafel tafel;

  public Taste(double pSpalte, double pZeile, String pAufschrift, int pRot, int pGruen, int pBlau) {
    xPosition = -107 + pSpalte * 72;
    yPosition = 126 + pZeile * -77;

    farbeRot = pRot;
    farbeGruen = pGruen;
    farbeBlau = pBlau;

    this.text = pAufschrift;
    tafel = new GLTafel(xPosition, yPosition, 1, 50, 50);
    tafel.setzeFarbe(farbeRot, farbeGruen, farbeBlau);
    tafel.setzeText(pAufschrift, 30 - (pAufschrift.length() - 1) * 5);
  }

  public void setzeFarbeNormal() {
    tafel.setzeFarbe(farbeRot, farbeGruen, farbeBlau);
  }

  public void setzeFarbeGedrueckt() {
    tafel.setzeFarbe(16, 16, 16);
  }

  public String gibAufschrift() {
    return tafel.gibText();
  }

  public GLTafel gibTafel() {
    return tafel;
  }

}
