import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * Beschreibung
 *
 * @version 1.0 vom 30.08.2015
 * @author 
 */

public class TaschenrechnerGUI extends JFrame {
  // Swing-Objekte
  private JTextField tfAnzeige = new JTextField();
  private JButton bAC = new JButton();
  private JButton bProzent = new JButton();
  private JButton bSQRT = new JButton();
  private JButton bPlus = new JButton();
  private JButton b1 = new JButton();
  private JButton b4 = new JButton();
  private JButton b7 = new JButton();
  private JButton b2 = new JButton();
  private JButton b3 = new JButton();
  private JButton b5 = new JButton();
  private JButton b6 = new JButton();
  private JButton b8 = new JButton();
  private JButton b9 = new JButton();
  private JButton bMinus = new JButton();
  private JButton bMal = new JButton();
  private JButton bGeteilt = new JButton();
  private JButton b0 = new JButton();
  private JButton b = new JButton();
  private JButton bGleich = new JButton();
  private JButton bVorzeichen = new JButton();
  
   //Recheneinheit und Hilfsvariablen zum Aufbauen der Zahlen aus Einzelzeichen
  private Recheneinheit recheneinheit;
  private boolean neueZahl=false;
  private boolean komma=false;

  public TaschenrechnerGUI() { 
    // Frame-Initialisierung
    super("Taschenrechner");
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 387; 
    int frameHeight = 415;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    setTitle("TaschenrechnerGUI");
    tfAnzeige.setBounds(16, 16, 342, 60);
    tfAnzeige.setHorizontalAlignment(SwingConstants.RIGHT);
    tfAnzeige.setFont(new Font("Dialog", Font.PLAIN, 24));
    cp.add(tfAnzeige);
    bAC.setBounds(16, 96, 75, 41);
    bAC.setText("AC");
    bAC.setMargin(new Insets(2, 2, 2, 2));
    bAC.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bAC_ActionPerformed(evt);
        }
      });
    cp.add(bAC);
    bSQRT.setBounds(104, 96, 75, 41);
    bSQRT.setText("SQRT");
    bSQRT.setMargin(new Insets(2, 2, 2, 2));
    bSQRT.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bSQRT_ActionPerformed(evt);
        }
      });
    cp.add(bSQRT);
    bProzent.setBounds(192, 96, 75, 41);
    bProzent.setText("%");
    bProzent.setMargin(new Insets(2, 2, 2, 2));
    bProzent.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bProzent_ActionPerformed(evt);
        }
      });
    cp.add(bProzent);
    bPlus.setBounds(280, 96, 75, 41);
    bPlus.setText("+");
    bPlus.setMargin(new Insets(2, 2, 2, 2));
    bPlus.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bPlus_ActionPerformed(evt);
        }
      });
    cp.add(bPlus);
    b1.setBounds(16, 152, 75, 41);
    b1.setText("1");
    b1.setMargin(new Insets(2, 2, 2, 2));
    b1.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b1_ActionPerformed(evt);
        }
      });
    cp.add(b1);
    b4.setBounds(16, 208, 75, 41);
    b4.setText("4");
    b4.setMargin(new Insets(2, 2, 2, 2));
    b4.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b4_ActionPerformed(evt);
        }
      });
    cp.add(b4);
    b7.setBounds(16, 264, 75, 41);
    b7.setText("7");
    b7.setMargin(new Insets(2, 2, 2, 2));
    b7.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b7_ActionPerformed(evt);
        }
      });
    cp.add(b7);
    b2.setBounds(104, 152, 75, 41);
    b2.setText("2");
    b2.setMargin(new Insets(2, 2, 2, 2));
    b2.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b2_ActionPerformed(evt);
        }
      });
    cp.add(b2);
    b3.setBounds(192, 152, 75, 41);
    b3.setText("3");
    b3.setMargin(new Insets(2, 2, 2, 2));
    b3.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b3_ActionPerformed(evt);
        }
      });
    cp.add(b3);
    b5.setBounds(104, 208, 75, 41);
    b5.setText("5");
    b5.setMargin(new Insets(2, 2, 2, 2));
    b5.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b5_ActionPerformed(evt);
        }
      });
    cp.add(b5);
    b6.setBounds(192, 208, 75, 41);
    b6.setText("6");
    b6.setMargin(new Insets(2, 2, 2, 2));
    b6.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b6_ActionPerformed(evt);
        }
      });
    cp.add(b6);
    b8.setBounds(104, 264, 75, 41);
    b8.setText("8");
    b8.setMargin(new Insets(2, 2, 2, 2));
    b8.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
         b8_ActionPerformed(evt);
        }
      });
    cp.add(b8);
    b9.setBounds(192, 264, 75, 41);
    b9.setText("9");
    b9.setMargin(new Insets(2, 2, 2, 2));
    b9.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b9_ActionPerformed(evt);
        }
      });
    cp.add(b9);
    bMinus.setBounds(280, 152, 75, 41);
    bMinus.setText("-");
    bMinus.setMargin(new Insets(2, 2, 2, 2));
    bMinus.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bMinus_ActionPerformed(evt);
        }
      });
    cp.add(bMinus);
    bMal.setBounds(280, 208, 75, 41);
    bMal.setText("*");
    bMal.setMargin(new Insets(2, 2, 2, 2));
    bMal.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bMal_ActionPerformed(evt);
        }
      });
    cp.add(bMal);
    bGeteilt.setBounds(280, 264, 75, 41);
    bGeteilt.setText("/");
    bGeteilt.setMargin(new Insets(2, 2, 2, 2));
    bGeteilt.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bGeteilt_ActionPerformed(evt);
        }
      });
    cp.add(bGeteilt);
    b0.setBounds(16, 320, 75, 41);
    b0.setText("0");
    b0.setMargin(new Insets(2, 2, 2, 2));
    b0.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          b0_ActionPerformed(evt);
        }
      });
    cp.add(b0);
    b.setBounds(104, 320, 75, 41);
    b.setText(".");
    b.setMargin(new Insets(2, 2, 2, 2));
    b.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bKomma_ActionPerformed(evt);
        }
      });
    cp.add(b);
    bGleich.setBounds(280, 320, 75, 41);
    bGleich.setText("=");
    bGleich.setMargin(new Insets(2, 2, 2, 2));
    bGleich.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent evt) { 
          bGleich_ActionPerformed(evt);
        }
      });
    cp.add(bGleich);
    bVorzeichen.setBounds(192, 320, 75, 41);
    bVorzeichen.setText("+/-");
    bVorzeichen.setMargin(new Insets(2, 2, 2, 2));
    bVorzeichen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        bVorzeichen_ActionPerformed(evt);
      }
    });
    cp.add(bVorzeichen);
    // Ende Komponenten

    setVisible(true);

    recheneinheit = new Recheneinheit();
    neueZahl = true;
    komma = false;
  } // end of public TaschenrechnerGUI

  // Anfang Methoden

  //liefert die anzeige des Taschenrechners als Zahl vom Typ double
  public double gibAnzeigeAlsZahl() {
    return Double.parseDouble(tfAnzeige.getText());
  }
  
  
  public void b1_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
       tfAnzeige.setText(""+"1");
       neueZahl = false;
    } else {
        tfAnzeige.setText(anzeigeText+"1");
    }
  }
  
  public void b2_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"2");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"2");
        }
  }
  
  public void b3_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"3");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"3");
        }
  }
  
 public void b4_ActionPerformed(ActionEvent evt) {
   String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"4");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"4");
        } 
 }

 public void b5_ActionPerformed(ActionEvent evt) {
   String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"5");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"5");
        } 
 }
 
  public void b6_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"6");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"6");
        }
  }
  
  public void b7_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"7");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"7");
        }
  } 
  
  public void b8_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"8");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"8");
        }
  }
  
  public void b9_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText(""+"9");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"9");
        }
  }
  
  public void b0_ActionPerformed(ActionEvent evt) {
    String anzeigeText = tfAnzeige.getText();
    if (anzeigeText.equals("0") || anzeigeText.equals("0.0") || neueZahl){
            tfAnzeige.setText("0");
            neueZahl = false;
        } else {
            tfAnzeige.setText(anzeigeText+"0");
        }
  }

  public void bKomma_ActionPerformed(ActionEvent evt) {
        String anzeigeText = tfAnzeige.getText();
        if (neueZahl) {
            tfAnzeige.setText("0.");
            neueZahl=false;
            komma = true;
        } else if (!komma) {
             tfAnzeige.setText(anzeigeText+".");
             komma = true;
        }
  }
  
  public void bGleich_ActionPerformed(ActionEvent evt) {
     double zahl = gibAnzeigeAlsZahl();
     recheneinheit.verarbeiteGrundrechenoperator(zahl);
     tfAnzeige.setText(""+recheneinheit.gibZahlspeicher());
     recheneinheit.speichereGrundrechenoperator("");
     neueZahl = true; 
  }                                                                   

  public void bPlus_ActionPerformed(ActionEvent evt) {
     double zahl = gibAnzeigeAlsZahl();
     recheneinheit.verarbeiteGrundrechenoperator(zahl);
     tfAnzeige.setText(""+recheneinheit.gibZahlspeicher());
     recheneinheit.speichereGrundrechenoperator("+");
     neueZahl = true; 
     komma=false;
  }
  
  public void bMinus_ActionPerformed(ActionEvent evt) {
     double zahl = gibAnzeigeAlsZahl();
     recheneinheit.verarbeiteGrundrechenoperator(zahl);
     tfAnzeige.setText(""+recheneinheit.gibZahlspeicher());
     recheneinheit.speichereGrundrechenoperator("-");
     neueZahl = true;  
     komma=false;
  }

  public void bMal_ActionPerformed(ActionEvent evt) {
     double zahl = gibAnzeigeAlsZahl();
     recheneinheit.verarbeiteGrundrechenoperator(zahl);
     tfAnzeige.setText(""+recheneinheit.gibZahlspeicher());
     recheneinheit.speichereGrundrechenoperator("*");
     neueZahl = true;   
     komma=false;
  }
  
  public void bGeteilt_ActionPerformed(ActionEvent evt) {
     double zahl = gibAnzeigeAlsZahl();
     recheneinheit.verarbeiteGrundrechenoperator(zahl);
     tfAnzeige.setText(""+recheneinheit.gibZahlspeicher());
     recheneinheit.speichereGrundrechenoperator("/");
     neueZahl = true;    
     komma=false;
  }
  
  public void bAC_ActionPerformed(ActionEvent evt) {
    recheneinheit.zuruecksetzen();
    tfAnzeige.setText("0");
  }

  public void bProzent_ActionPerformed(ActionEvent evt) {
    double zahl = gibAnzeigeAlsZahl();
     double ergebnis = recheneinheit.liefereProzentwert(zahl);
    tfAnzeige.setText(""+ergebnis);
    neueZahl = true;
    komma=false;
  }

  public void bSQRT_ActionPerformed(ActionEvent evt) {
    double zahl = gibAnzeigeAlsZahl();
    double ergebnis = recheneinheit.liefereQuadratwurzel(zahl);
    tfAnzeige.setText("" + ergebnis);  
    neueZahl = true;
    komma=false;
  }

  public void bVorzeichen_ActionPerformed(ActionEvent evt) {
    double zahl = gibAnzeigeAlsZahl();
    double ergebnis = recheneinheit.liefereGegenzahl(zahl);
    tfAnzeige.setText("" + ergebnis);
    neueZahl = true;
    komma=false;
  } 
  // Ende Ereignismethoden
  public static void main(String[] args) {
    TaschenrechnerGUI rechner = new TaschenrechnerGUI();
  }
  
} // end of class TaschenrechnerGUI
